<?php

/*
Plugin Name: wp2epub
Plugin URI: http://blog.tcrouzet.com/wp2epub/
Description: wp2epub generate epub files, ready to publish, for iPad, iPhone and other readers. Just choose the tags, categories or dates to export. It's done. You are now a bloguer and a writer. wp2epub also export in html, and then you can open with a wordprocessor to convert into PDF or other formats. A good way to backup your blog.
Author: Thierry Crouzet
Version: 0.50
Author URI: http://blog.tcrouzet.com/
*/

// CHANGE THIS IF YOU WANT TO USE A DIFFERENT BACKUP LOCATION
define('WP_EPUB_DIR', 'wp-content/epub');
define('WP_EPUB_TABLE', $wpdb->prefix.'wp2epub');
define('WP_EPUB_SAVEDIR', ABSPATH.WP_EPUB_DIR.'/');
define('WP_EPUB_VER',0.50);

class wp2epub{
	
	function __construct(){
	}

	function maker(){
		$this->debug=false;
		
		//print_r($_POST);
		if(!empty($_POST['do_ok'])){
			global $wpdb;
			ini_set("display_errors","1");
			ini_set("memory_limit","1024M");
			$this->okfile=array();
			
			//Looking for fields
			$remouve="";
			$mores=array();
			$keys=array_keys($_POST);
			foreach($keys as $key){
				$index=str_replace("do_name","",$key);
				if(empty($_POST['do_base_all'])&&empty($index)&&(empty($_POST['do_name'.$index])||empty($_POST['do_author'.$index]))){
					$mores=array();
					$this->export_error("You must fill file name and author name!");
					break;
				}
				if(eregi("do_name",$key)){
					//echo("$key<br>");
					if(!empty($_POST['do_name'.$index]) && !empty($_POST['do_author'.$index])){
						if(empty($index)){
							//New book
							$mores=array();
							$mores[]=$index;
							break;
						}elseif(!empty($_POST['do_remouve'.$index])){
							$remouve=str_replace("_","",$index);
							$mores=array();
							break;
						}elseif(!empty($_POST['do_base'.$index])){
							//Generate only one
							$mores=array();
							$mores[]=$index;
							break;
						}else{
							$mores[]=$index;
						}	
					}
				}
			}
			//print_r($mores);
			if(!empty($remouve)){
				$query="DELETE FROM ".WP_EPUB_TABLE." WHERE epub_num='$remouve'";
				if( $wpdb->query($query)){
					$this->export_error("ePub remouved.");
				}
			}
			
			//Save
			foreach($mores as $more){
				if(empty($_POST['do_order'.$more])) $e->epub_order=0; else $e->epub_order=1;
				if(empty($_POST['do_com'.$more])) $e->epub_com=0; else $e->epub_com=1;
				if(empty($_POST['do_nodates'.$more])) $e->epub_nodates=0; else $e->epub_nodates=1;
				if(empty($_POST['do_french'.$more])) $e->epub_french=0; else $e->epub_french=1;
				if(empty($_POST['do_content'.$more])) $e->epub_content=0; else $e->epub_content=1;
				if(empty($_POST['do_source'.$more])) $e->epub_source=0; else $e->epub_source=1;
				
				//Cover
				$img="";
				if(!empty($_FILES['do_cover'.$more]->name)){
					$imgcover=$this->preloadImage($_FILES['do_cover'.$more]);
					//print_r($imgcover);
					if(!empty($imgcover->tmp)){
						rename($imgcover->tmp,WP_EPUB_SAVEDIR.$imgcover->name);
						$img=serialize($imgcover);
					}
				}
				
				$e->epub_author=stripslashes($_POST['do_author'.$more]);
				$e->epub_title=stripslashes(($_POST['do_title'.$more]));
				$e->epub_subtitle=stripslashes(($_POST['do_subtitle'.$more]));
				$e->epub_tags=stripslashes($_POST['do_tags'.$more]);
				$e->epub_dates=stripslashes($_POST['do_dates'.$more]);
				$e->epub_copyright=stripslashes($_POST['do_copyright'.$more]);
				$e->epub_colophon=stripslashes($_POST['do_colophon'.$more]);
				$e->epub_style=stripslashes($_POST['do_style'.$more]);
				$e->epub_intropost=stripslashes($_POST['do_intropost'.$more]);
				//print_r($e);
				//echo(serialize($e)."<br>");
				
				$num=intval($remouve=str_replace("_","",$more));
				$set="epub_data='".addslashes(serialize($e))."'";
				if(!empty($img)) $set.=",epub_cover='$img'";
				$name=mb_strtolower(str_replace(array(" ","'"),"",$_POST['do_name'.$more]));
				if(!empty($more)){
					$query="UPDATE LOW_PRIORITY ".WP_EPUB_TABLE." SET epub_name='".mysql_real_escape_string($name)."',$set WHERE epub_num='$num'";
					//echo($query);
					//$this->export_error("update $num.");
					$wpdb->query($query);
					$this->perform_export($num);
				}else{
					$query="INSERT LOW_PRIORITY INTO ".WP_EPUB_TABLE." SET epub_name='".mysql_real_escape_string($name)."',$set";
					$query.=" ON DUPLICATE KEY UPDATE $set;";
					$wpdb->query($query);
				}
			}
		}		
	}
	
	function mem_option($name,$value=""){
		if(!add_option($name,$value)){
			update_option($name,$value);
		}
	}
	
	function table_exists($table){
		global $wpdb;
		$query="show tables like '$table'";
		if($wpdb->query($query)==1) return true; else return false;
	}
	
	function print_error(){
		echo '<div class="updated error">' . __('The following messages were reported:');
		foreach($this->export_errors as $error) {
			echo "<p>{$error}</p>\n";
		}
		echo "</div>";
	}
	
	function menu() {
		global $wpdb;
		$feedback='';
		$WHOOPS=FALSE;
		
		//Versioning
		$ver=get_option('wp2epub_ver');
		//echo(WP_EPUB_VER." ".get_option('wp2epub_ver')." ".$ver);
		if($ver!=WP_EPUB_VER){
			$newver=true;
			$this->mem_option('wp2epub_ver',WP_EPUB_VER);
		}else
			$newver=false;
		
		echo "<div class='wrap'>";
		echo '<h2>' . __('wp2epub') . '</h2>';
		echo 'Convert your blog to ePub by <a href="http://tcrouzet.com">Thierry Crouzet</a> (<a href="http://blog.tcrouzet.com/wp2epub/">plugin page</a>, version: '.WP_EPUB_VER.').';
		
		if($newver) echo '<p>You are running a new version:'.WP_EPUB_VER.'</p>';
		
		$phpver=intval(phpversion());		
		if($phpver<5){
			$this->export_error(__('WARNING: Your server run PHP '.phpversion().'. You need PHP 5 or upper to run this plugin in good conditions. You can have bugs, but nothing fatal for your blog. Try!'));
		}
		
		if(!file_exists(WP_EPUB_SAVEDIR)){
			if(@mkdir(WP_EPUB_SAVEDIR)){
				// Give the new dirs the same perms as wp-content.
				$stat = stat( ABSPATH . 'wp-content' );
				$dir_perms = $stat['mode'] & 0000777; // Get the permission bits.
				@chmod(WP_EPUB_SAVEDIR,$dir_perms);
			}else{
				$this->export_error(__('WARNING: Your <strong>'.ABSPATH.'wp-content directory</strong> is <strong>NOT</strong> writable! We can not create the backup directory <strong>'.WP_EPUB_SAVEDIR.'</strong>. Use your FTP software to change the file mode.'));
				$this->print_error();
				echo "</div>";
				return false;
			}
		}
		if(!is_writable(WP_EPUB_SAVEDIR)){
			$this->export_error(__('WARNING: Your <strong>'.WP_EPUB_SAVEDIR.'</strong> directory is <strong>NOT</strong> writable! We can not create the <strong>epub</strong> directory. Use your FTP sofware to change the file mode.'));
			$this->print_error();
			echo "</div>";
			return false;
		}
		if(!file_exists(WP_EPUB_SAVEDIR.'index.php') ) {
			@touch(WP_EPUB_SAVEDIR."index.php");
		}
		if($newver) @unlink(WP_EPUB_SAVEDIR.'.htaccess');
		if(!file_exists(WP_EPUB_SAVEDIR.'.htaccess')){
			$handle=fopen(WP_EPUB_SAVEDIR.".htaccess","w");
			if($handle){
				fwrite($handle,"RewriteEngine on\n");
				fwrite($handle,"RewriteRule ^index\.php$ ".ABSPATH."wp-content/plugins/wp2epub/myphp/list.php?abspath=".WP_EPUB_SAVEDIR."&baseurl=".get_settings('siteurl')."&%{QUERY_STRING} [L]\n");
				fclose($handle);
			}else{
				$this->export_error(__('WARNING: Imposible to create .htaccess. '.WP_EPUB_SAVEDIR));
			}
		}

		//The first time create WP_EPUB_TABLE
		if(WP_EPUB_VER<0.17){
			//Drop table
			$query="DROP TABLE `".WP_EPUB_TABLE."`";
			$tmp=$wpdb->query($query);
			$this->export_error(__('Drop table with this version to a better one!!! Sorry!!!'));
			
		}
		if(!$this->table_exists(WP_EPUB_TABLE)){
			$query="CREATE TABLE `".WP_EPUB_TABLE."` (`epub_num` int(11) NOT NULL auto_increment,`epub_name` VARCHAR( 20 ) CHARACTER SET ascii COLLATE ascii_bin NOT NULL,`epub_data` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,`epub_cover` text character set ascii collate ascii_bin, PRIMARY KEY  (`epub_num`),UNIQUE (`epub_name`)) ENGINE = MYISAM;";
			$newtable=$wpdb->query($query);		
		}
		
		// did we just do a backup?  If so, let's report the status
		if(count($this->okfile)){
			$feedback = '<div class="updated"><p>' . __('ePub generation successful') . '!</p>';
			$feedback .= '<p>' . __('Your ePub backup file has been saved on the server at '.date('H:i \t\h\e Y-m-d').'. If you would like to download it now, right click and select "Save As"</p>');
			foreach($this->okfile as $file){
				$feedback .= '<p><a href="'.get_settings('siteurl')."/$file\">$file</a> : " . sprintf(__('%s bytes'), filesize(ABSPATH.$file))."</p>";
			}
			$feedback .= '</div>';
		}
		
		//Test function
		$opt=get_option('wp2epub_file_get_contents');
		if(empty($opt)){
			$img=@file_get_contents("http://blog.tcrouzet.com/images_tc//2006/12/2010_05_11a-309x350.jpg");
			if(empty($img))
				$this->mem_option('wp2epub_file_get_contents',1);	//Pb
			else
				$this->mem_option('wp2epub_file_get_contents',2);	//Fine
		}
		if($opt==1){
			$this->export_error(__('WARNING: Your <strong>file_get_contents()</strong> PHP function is limited. You can have problems with images.'));
		}
		
		//Errors
		if (count($this->export_errors)) {
			$this->print_error();
		}
		if (!empty($feedback)) echo $feedback;

		
		if(!$WHOOPS){
			echo '<form method="post" enctype="multipart/form-data">';
			echo '<input type="hidden" name="do_ok" value="1">';
			
			$query="SELECT * FROM ".WP_EPUB_TABLE." ORDER BY epub_num ASC";
			$efiles=$wpdb->get_results($query);
			if($efiles){
				$c=count($efiles);
				if($c==1) $c="1 epub"; else $c="$c epubs";
				echo '<p><a href="'.get_settings('siteurl')."/".WP_EPUB_DIR.'"/index.php" target="_blank">Index of '.$c.'</a></p>';
			}else{
				echo '<p><b>Fill in the fields and save.</b></p>';
			}
			echo '<table style="border:none;border-collapse:collapse;width:100%">';
			$bak='';
			if($efiles){
				foreach($efiles as $e){
					if($bak=="#AAA") $bak="#DDD"; else $bak="#AAA";
					//print_r($e);
					$this->form_line($e,$bak);
				}
			}

			if($bak=="#AAA") $bak="#DDD"; else $bak="#AAA";
			$this->form_line("",$bak);
						
			echo '</table>';
			echo '<p class="submit"><input type="submit" name="do_base_all" value="Save and generate all!" / ></p>';
			
			echo '</form>';
			
			echo '<h3>Help!</h3><ol>';
			echo '<li>ePub file name must be unique, no space.</li>';
			echo '<li>Author must be filled.</li>';
			echo '<li>Title is the name of the book. Exemple: The Da Vinci Code :-)</li>';
			echo '<li>Sub title only if you want.</li>';
			echo '<li>List tags or categories separeted by comas. Insert a - before a tag or a category to exclude it. Exemple: "politics,-USA" will include all the posts with the tag politics but not those with USA even if they have the tag politics.</li>';
			echo '<li>You can filter by date. The dates separated by comas. Exemples: "2010" or "2008,2009" or "2010:05" or "2010:05:30". You can also exclude date with -. Exemple : "2010,-2010:01".</li>';
			echo '<li>By default posts will be published chronologically starting with the oldest. Check Reverse: the book will start with the most recent post.</li>';
			echo '<li>Check to publish the comments.</li>';
			echo '<li>With no dates checked, there is no date for the posts.</li>';
			echo '<li>French will print dates in French.</li>';
			echo '<li>Content will build a complete table of contents.</li>';
			echo '<li>Source will print the permalink at the bottom od the post.</li>';
			echo '<li>In Introduction post number you can put the number of a special post. It will be printed at the bigining of the file.</li>';
			echo '<li>The copyright page is the first page after the cover. You can use HTML and fields: [title], [subtitle], [blog], [author], [blogurl], [year], [today].</li>';
			echo '<li>The colophon page is the last page of the book.</li>';
			echo '<li>You can upload a picture for your cover. Better on iPad!</li>';
			echo '<li>Put your css in '.$this->style_dir().' to have more options. Copy the original style.css and make changes.</li>';
			echo '<li>The first time, clic on <b>Save</b> to save your book. Then clic on <b>Save & generate</b> to build the epub file.</li>';
			echo '<li>Wait sometime a long time. The ePub is building.</li>';
			echo '<li>On Windows, Mac OS or Linux, download ePubs and open them on <a href="http://www.lexcycle.com/">Stanza</a> or, better, <a href="http://calibre-ebook.com/">Calibre</a> (ergonomic) or <a href="http://lucidor.org/">Lucidor</a> (strict). Or on a reader like the Sony-PRS, iPad, iPhone.</li>';
			echo '<li>Validate your ePub from <a href="http://threepress.org/document/epub-validate/">epubChecker</a>. Warning: you can have problems in your posts.</li>';
			echo '<li>Deflate the zip file and you can open de htm file with a word processor and convert it in PDF or other formats.</li>';
			echo '<li>Personalyse the look by editing '.$this->style_dir().'.</li>';
			echo '</ol>';
			echo '<h3>Tips</h3><ol>';
			echo '<li>Tag the posts you dont want to export with a tag, "noepub" for example, and create a filter on it "-noepub".</li>';
			echo '</ol>';
		}
		
		echo '</div>';
		
	}// end menu()

	function form_line($e="",$bak){
		if(!empty($e)){
			$efile=$this->formatdatas($e->epub_data);
			$file=WP_EPUB_SAVEDIR.$e->epub_name.'.epub';
			$testfile=file_exists($file);
			$book='Book #'.$e->epub_num;
			$imgcover=unserialize($e->epub_cover);
			$fileimg=WP_EPUB_SAVEDIR.$imgcover->name;
			$testimg=file_exists($fileimg);
			$e->epub_num="_".$e->epub_num;
			$button="Save & generate";
		}else{
			$testfile=false;
			$book="New Book";
			$testimg=false;
			$e->epub_num="";
			$efile->epub_copyright="<h1>[title]</h1>\n<h2>[blog]</h2>\n<h3>[author]</h3>\n<p>&copy; <a href=\"[blogurl]\">[author]</a> - [year]</p>";
			$efile->epub_colophon="<p><br /><br /><br />printed the [today] by wp2epub</p><br/><br/>Total signs: [signs]<br/>Book pages: [pages]";
			$button="Save";
		}
		$td=' style="width:95%"';
		
		echo '<tr style="background:'.$bak.'"><td colspan="4" style="width:100%;padding-top:15px;padding-bottom:10px"><b>'.$book.'</b>';
		if($testfile){
			echo ' <a href="'.get_settings('siteurl').'/'.WP_EPUB_DIR.'/'.$e->epub_name.'.epub">'.$e->epub_name.'.epub</a>';
			$filemhtl=WP_EPUB_SAVEDIR.$efile->epub_name.'.zip';
			if($filemhtl) echo ' <a href="'.get_settings('siteurl').'/'.WP_EPUB_DIR.'/'.$e->epub_name.'.zip">'.$e->epub_name.'.zip</a>';
		}
		echo '</td></tr><tr style="background:'.$bak.'">';
		echo '<td>ePub file name:<br/><input type="text" name="do_name'.$e->epub_num.'" value="'.$e->epub_name.'" '.$td.'></td>';
		echo '<td>Author:<br/><input type="text" name="do_author'.$e->epub_num.'" value="'.$efile->epub_author.'" '.$td.'></td>';
		echo '<td>Title:<br/><input type="text" name="do_title'.$e->epub_num.'" value="'.$efile->epub_title.'"'.$td.'></td>';
		echo '<td>Sub title:<br/><input type="text" name="do_subtitle'.$e->epub_num.'" value="'.$efile->epub_subtitle.'"'.$td.'></td>';
		echo '</tr><tr style="background:'.$bak.'">';
		echo '<td>Tags (ex: "politics,-USA"):<br/><input type="text" name="do_tags'.$e->epub_num.'" value="'.$efile->epub_tags.'"'.$td.'></td>';
		echo '<td>Dates (ex: "2010,-2010:01"):<br/><input type="text" name="do_dates'.$e->epub_num.'" value="'.$efile->epub_dates.'"'.$td.'></td>';
		echo '<td colspan="2">Reverse <input type="checkbox" name="do_order'.$e->epub_num.'" value="1" ';
		if($efile->epub_order==1) echo('checked');
		echo'/>';
		echo ' Comments <input type="checkbox" name="do_com'.$e->epub_num.'" value="1" ';
		if($efile->epub_com==1) echo('checked');
		echo'/>';
		echo ' No dates <input type="checkbox" name="do_nodates'.$e->epub_num.'" value="1" ';
		if($efile->epub_nodates==1) echo('checked');
		echo'/>';
		echo ' French <input type="checkbox" name="do_french'.$e->epub_num.'" value="1" ';
		if($efile->epub_french==1) echo('checked');
		echo'/>';
		echo ' Content <input type="checkbox" name="do_content'.$e->epub_num.'" value="1" ';
		if($efile->epub_content==1) echo('checked');
		echo'/>';
		echo ' Source <input type="checkbox" name="do_source'.$e->epub_num.'" value="1" ';
		if($efile->epub_source==1) echo('checked');
		echo'/>';
		echo ' Introduction post number:<input type="text" name="do_intropost'.$e->epub_num.'" value="'.$efile->epub_intropost.'" style="width:50px">';
		echo '</td>';
		echo '</tr><tr style="background:'.$bak.'">';
		echo '<td>Copyright page:<br/><textarea rows="5" name="do_copyright'.$e->epub_num.'" '.$td.'>'.$efile->epub_copyright.'</textarea></td>';
		echo '<td>Colophon page:<br/><textarea rows="5" name="do_colophon'.$e->epub_num.'" '.$td.'>'.$efile->epub_colophon.'</textarea></td>';
		
		echo '<td valin="top">Cover PNG (best 1024*768), max size '.ini_get('upload_max_filesize').':<br/><input type="file" name="do_cover'.$e->epub_num.'" value=""><br/>';
		if($testimg) echo '<a href="'.get_settings('siteurl').'/'.WP_EPUB_DIR.'/'.$imgcover->name.'" target="_blanc">'.$imgcover->name.'</a><br/>';
		echo 'Styles:<br/><select name="do_style'.$e->epub_num.'">';
		$styles=$this->listDirPattern($this->style_dir(),"*.css");
		foreach($styles as $style){
			echo '<option value="'.$style.'"';
			if($style==$efile->epub_style) echo("selected");
			echo '>'.$style.'</option>';
		}
		echo '</select>';
			
		echo '</td>';
		echo '<td>';
		if($testimg) echo '<img src="'.get_settings('siteurl').'/'.WP_EPUB_DIR.'/'.$imgcover->name.'" style="width:100px"/>';
		echo '</td>';
		echo '</tr>';
		
		echo '<tr style="background:'.$bak.'"><td colspan="4" style="width:100%;padding-bottom:15px">';
		echo ' <input type="submit" name="do_base'.$e->epub_num.'" value="'.$button.'" /> ';
		if(!empty($e->epub_num))
			echo '<input type="submit" name="do_remouve'.$e->epub_num.'" value="Remouve" />';
		echo '</td></tr>';
	}
	
	function export_error($err) {
		if(count($this->export_errors) < 20) {
			$this->export_errors[] = $err;
		} elseif(count($this->export_errors) == 20) {
			$this->export_errors[] = __('Subsequent errors have been omitted from this log.');
		}
	}

	/** liste file par alpha ou date_desc, date_asc */
	function listDirPattern($dirname,$pattern,$sort=""){
		if($dirname[strlen($dirname)-1]!='\\') $dirname.='';
		$handle=opendir($dirname);
		if(!$handle){
			$this->error="Dir does not exist";
			return false;
		}
		$result_array=array();
		$pattern=str_replace(array("\*","\?","#"),array(".*",".","[0-9]+"),preg_quote($pattern));
		while(false!==($file=readdir($handle))){
			if(($file==".")||($file=="..")) continue;
			if(!ereg("^".$pattern."$",$file)) continue;
			if(eregi("date",$sort)){
				$date=filemtime($dirname.$file);
				$result_array[$date]=$file;
			}else{
				$result_array[]=$file;
			}
		}
		if(eregi("date_desc",$sort)){
			krsort($result_array);
		}elseif(eregi("date_asc",$sort)){
			ksort($result_array);
		}elseif(empty($sort))
			sort($result_array);
		else
			arsort($result_array);
		closedir($handle);
		return $result_array;
	}

	/***********************
	 * real code 
	 ***********************/

	function perform_export($num=""){
		global $wpdb;
		if(empty($num)){
			$this->export_error(__('No epub file denifined!'));
		}else{
			$query="SELECT * FROM ".WP_EPUB_TABLE." WHERE epub_num='$num' LIMIT 1";
			$efiles=$wpdb->get_results($query);
			if($efiles){
				foreach($efiles as $e){
					$efile=$this->formatdatas($e->epub_data);
					$efile->epub_num=$e->epub_num;
					$efile->epub_name=$e->epub_name;
					$efile->epub_cover=$e->epub_cover;
					//print_r($efile);
					if($this->make_file($efile)) $this->make_htm_word($efile);
				}
			}else{
				$this->export_error(__('No epub file denifined!'));
			}
		}
	}
	
	//To use with other plugins
	function perform_externalexport($efile){
		$this->make_file($efile);
	}
	
	function formatdatas($e){
		//echo("<hr>$e<br>");
		$efile=unserialize($e);
		//print_r($efile);
		return $efile; 
	}
	
	function var_substitution($copy,$efile){
		$copy=str_replace("[title]",$efile->epub_title,$copy);
		$copy=str_replace("[subtitle]",$efile->epub_subtitle,$copy);
		$copy=str_replace("[blog]",$this->outHTTP(get_settings('siteurl')),$copy);
		$copy=str_replace("[blogurl]",get_settings('siteurl'),$copy);
		$copy=str_replace("[author]",$efile->epub_author,$copy);
		$copy=str_replace("[year]",date("Y"),$copy);
		$copy=str_replace("[today]",date("Y-n-j"),$copy);
		$copy=str_replace("[signs]",$this->totalsigns,$copy);
		$pages=intval($this->totalsigns/2000);
		$copy=str_replace("[pages]",$pages,$copy);
		return $copy;
	}
	
	function format_post($post,$efile,$normal=true){
		$this->totalsigns+=strlen(strip_tags($post->post_title.$post->post_content));
		$this->contener[$this->cindex]="";
		$this->title[$this->cindex]=$this->clean_title($post->post_title);
		$this->contener[$this->cindex].='<h1 class="main">'.$this->title[$this->cindex]."</h1>\n";
		$tmpstp=strtotime($post->post_date);
		if($normal){
			$this->year[$this->cindex]=date("Y",$tmpstp);
			$this->month[$this->cindex]=$this->traducdate(date("F",$tmpstp),$efile->epub_french);
		}
		if(!$efile->epub_nodates&&$normal){
			$this->contener[$this->cindex].='<div class="soustitre">';
			$this->contener[$this->cindex].=$this->traducdate(date("l j F Y",$tmpstp),$efile->epub_french);
			$this->contener[$this->cindex].="</div>\n";
		}
		$this->contener[$this->cindex].=$this->format_text($post->post_content);
		if(empty($this->contener[$this->cindex])) continue;
		
		//Source link
		if($efile->epub_source==1){
			//print_r($post);exit;
			$this->contener[$this->cindex].="\n<p><a href=\"".str_replace("http://www.tcrouzet.com/wordpress","http://blog.tcrouzet.com",$post->guid)."\">Source...</a></p>";
		}
		
		//Comments
		if($efile->epub_com==1){
			$wherecom="comment_post_ID='$post->ID'";
			$query="SELECT * FROM $wpdb->comments WHERE $wherecom ORDER BY comment_date ASC";
			//echo($query."<br>");
			//$ncomments = $wpdb->get_results("SELECT count(*) AS ncom FROM $wpdb->comments WHERE $wherecom");
			//$this->ncom+=$ncomments[0]->ncom;
			$comments=$wpdb->get_results($query);
			if($comments){
				$this->comnumber=0;
				$msg="";
				foreach($comments as $key => $c){
					if(eregi("This comment was originally posted",$c->comment_content)) continue;
					if(eregi("Topsy.com",$c->comment_author)) continue;						
					$this->comnumber++;
					$msg.="\n<h4>".strip_tags($c->comment_author)."</h4>\n".$this->format_text(strip_tags($c->comment_content));
					if($key>3) break;
				}
				$this->contener[$this->cindex].="\n<hr /><h4>".$this->comnumber." commentaires</h4>\n".$msg;
			}
		}		
	}

	function make_file($efile){
		global $wpdb;
		
		require_once("simplehtmldom/simple_html_dom.php");
		
		$this->imgindex=1;
		$this->imgtab=array();
			
		$this->contener=array();
		$this->year=array();
		$this->month=array();
		$this->title=array();
		$this->totalsigns=0;
		$this->cindex=1;
		
		$this->ncom=0;		//Comments overall number
			
		//Cover
		if(!empty($efile->epub_cover)){
			$imgcover=unserialize($efile->epub_cover);
			$this->cover=$this->cover_make($imgcover);
		}else{
			$this->cover='<div class="first">';
			$this->cover.='<h1>'.$efile->epub_title."</h1>\n";
			$this->cover.='<h4>'.$efile->epub_subtitle.'</h4>';
			$this->cover.='<h3>'.$efile->epub_author."</h3>\n";
			$this->cover.="</div>\n";
			$this->cover=$this->ops_maker($this->cover,$efile);
		}

		//Copyright page
		$this->copyright='<div class="first">'.$this->var_substitution($efile->epub_copyright,$efile)."</div>\n";
		
		if(count($efile->epub_posts)){
			$posts=$efile->epub_posts;
		}else{
			$query=$this->make_query($efile);
			$posts=$wpdb->get_results($query);
		}
		$this->export_complete = false;
		if(!$posts){
			$this->export_error(__('No post find! '.$query));
			return;
		}
		
		//Introduction post
		if($efile->epub_intropost>0){
			$post=$this->get_one_post($efile->epub_intropost);
			if($post){
				$this->format_post($post,$efile,false);
				$this->new_page();
			}
		}
		
		foreach($posts as $post){
			$this->format_post($post,$efile);
			//echo($this->cindex." ".$post->post_title."<br/>");
			$this->new_page();
		}
		
		//Colophon
		$this->colophon='<div class="last">'.$this->var_substitution($efile->epub_colophon,$efile)."</div>\n";
		
		if($this->debug) exit;
		
		$this->epub_title=$efile->epub_title;
		$this->epub_author=$efile->epub_author;
		$this->epub_isbn="";
		$this->epub_french=$efile->epub_french;
		$this->okfile[]=$this->make_epub($efile);
		return true;
	}

	function make_query($efile){
		global $wpdb;

		$ids=array();
		$exclude=array();
		$names=array();
		$tags=trim($efile->epub_tags);
		$tags=trim($tags,",");
		$tags=trim($tags);
		$tags=explode(",",$tags);
		if(count($tags)){
			$q="";
			foreach($tags as $tag){
				$originaltag=trim($tag);
				$tag=trim($tag,"-");
				if($originaltag!=$tag) $exclude[]=$tag;
				if(empty($tag)) continue;
				if(!empty($q)) $q.=" OR ";
				$q.="name='".addslashes(trim($tag))."'";
			}
			//echo($q."<br>");
			if(!empty($q)){
				$query="SELECT term_taxonomy_id,name FROM ".$wpdb->terms.",".$wpdb->term_taxonomy." WHERE ".$wpdb->terms.".term_id=".$wpdb->term_taxonomy.".term_id AND ($q)";
				//echo($query."<br>");
				$term_taxonomy_id=$wpdb->get_results($query);
				foreach($term_taxonomy_id as $id){
					$ids[]=$id->term_taxonomy_id;
					$names[$id->term_taxonomy_id]=$id->name;
				}
				//print_r($ids);
				//print_r($names);
			}
		}
		
		$total=count($ids);
		$termouts=array();
		$neototal=$total;
		$qterms="";
		if($total>0){
			$qterms="";
			$first=true;
			foreach($ids as $id){
				if(!$first) $qterms.=" OR ";
				if(in_array($names[$id],$exclude,true)) {$neototal--;$termouts[]=$id;}
				$qterms.="term_taxonomy_id='".$id."'";
				$first=false;
			}
		}
		
		//print_r($exclude);print_r($ids);print_r($termouts);echo("$total $neototal<br>");
		if($total==1&&$neototal==1){
			$query="SELECT * FROM ".$wpdb->term_relationships.",".$wpdb->posts." WHERE object_id=ID AND ($qterms) AND ";
		}elseif($total>0&&$neototal>0){
			$query="SELECT *,COUNT(DISTINCT term_taxonomy_id) as termsnbr FROM ".$wpdb->term_relationships.",".$wpdb->posts." WHERE object_id=ID AND ($qterms) AND ";
		}elseif($total>0&&$neototal==0){
			$query="SELECT *,GROUP_CONCAT(DISTINCT term_taxonomy_id SEPARATOR ',') AS termsids FROM ".$wpdb->term_relationships.",".$wpdb->posts." WHERE object_id=ID AND ";
		}else{
			$query="SELECT * FROM ".$wpdb->posts." WHERE ";
		}
		$query.="post_status='publish' AND post_type='post'";

		//$query.=" AND ID='16298'";			//test on a single post		
		
		//Dates
		if(!empty($efile->epub_dates)){
			$dates=explode(",",$efile->epub_dates);
			$dquery="";
			foreach($dates as $date){
				list($y,$m,$d)=explode(":",$date);
				if(empty($y)) continue;
				$ny=trim($y,"-");
				if($ny!=$y) {$like="NOT LIKE";$op=" AND ";} else {$like="LIKE";$op=" OR ";}
				$y=$ny;
				$dd=$y."-";
				if(!empty($m)){
					$dd.=$m."-";
					if(!empty($d)) $dd.=$d;
				}
				$dd.="%";
				if(empty($dquery)) $dquery.=" ("; else $dquery.=$op;
				$dquery.="post_date ".$like." '$dd'";
			}
			if(!empty($dquery)){
				$query.=" AND ".$dquery.")";
			}
		}
		
		if($total==1&&$neototal==1){
		}elseif($total>0&&$neototal==0){
			$tmp="";
			foreach($termouts as $term){
				//$query.=" AND term_taxonomy_id<>$term";
				if(!empty($tmp)) $tmp.=" AND ";
				$tmp.="NOT FIND_IN_SET('$term',termsids)";
			}
			//$query.=" GROUP BY ID";
			$query.=" GROUP BY ID HAVING $tmp";
		}elseif($total>0){
			$qg="";
			if($neototal>0) $qg="termsnbr=$neototal";
			foreach($termouts as $term){
				if(!empty($qg)) $qg.=" AND ";
				$qg.="term_taxonomy_id<>$term";
			}
			$query.=" GROUP BY ID";
			if(!empty($qg)) $query.=" HAVING $qg";			 
		}
		
		$query.=" ORDER BY post_date_gmt ";
		if($efile->epub_order==1) $query.="DESC"; else $query.="ASC";   
		//$query.=" LIMIT 6";

		//echo($query."<br>");exit;
		return $query;		
	}
	
	function get_one_post($id){
		global $wpdb;
		$query="SELECT * FROM ".$wpdb->term_relationships.",".$wpdb->posts." WHERE ID='$id'";
		return $wpdb->get_row($query);
	}
	
	function style_dir(){
		return ABSPATH."wp-content/plugins/wp2epub/css/";
	}

	function style_path($efile){
		return $this->style_dir().$efile->epub_style;
	}

	function make_style($efile){
		return @file_get_contents($this->style_path($efile));
	}
	
	function make_epub($efile){
		require_once("zipcreate/zipcreate.class.php");
		$tstamp = time();		// timestamp for zip entries
		$epub= new ZipCreate();
		
		$imgcover="";
	
		$prev_encoding = $epub->ztype;
		$epub->ztype = 'store';
		$epub->add_file('application/epub+zip', 'mimetype', $tstamp);
		$epub->ztype = $prev_encoding;
	
		//META-INF
		$epub->add_file($this->make_container(),'META-INF/container.xml',$tstamp);

		//Cover
		if(!empty($efile->epub_cover)){
			$imgcover=unserialize($efile->epub_cover);
			$epub->add_file(@file_get_contents(WP_EPUB_SAVEDIR.$imgcover->name),'OEBPS/images/imgcover.'.$imgcover->type, $tstamp);
		}else{
			$imgcover="";
		}
		$epub->add_file($this->cover,'OEBPS/text/cover.xhtml',$tstamp);
		$epub->add_file($this->ops_maker($this->copyright,$efile),'OEBPS/text/copyright.xhtml',$tstamp);
		
		//OEBPS
		$epub->add_file($this->opf_maker($efile,$imgcover), 'OEBPS/content.opf', $tstamp);	//Files listing
		$epub->add_file($this->ncx_maker($efile), 'OEBPS/toc.ncx', $tstamp);				//Navigation, table of contents
		foreach($this->contener as $key => $ops){
			$epub->add_file($this->ops_maker($ops,$efile),'OEBPS/text/book'.str_pad($key,4,"0",STR_PAD_LEFT).'.xhtml',$tstamp);
		}
		$epub->add_file($this->ops_maker($this->colophon,$efile),'OEBPS/text/colophon.xhtml',$tstamp);
		
		//CSS
		$epub->add_file($this->make_style($efile),'OEBPS/styles/main.css', $tstamp);
		
		//Images
		foreach($this->imgtab as $key => $value){
			//$img=@file_get_contents($this->abspath($value));
			$img=@file_get_contents($this->localise_file($value));
			$ext=$this->imgxtension($value);
			if(empty($img)){
				$img=file_get_contents(ABSPATH."wp-content/plugins/wp2epub/images/notloaded.png");
				$ext="png";
			}
			$epub->add_file($img,'OEBPS/images/'.$key.'.'.$ext, $tstamp);
		}
		
		// finish it up and download
		$output_file = $epub->build_zip();
		$output_name=$efile->epub_name.".epub";
		$this->export_file=WP_EPUB_DIR."/".$output_name;
		if(isset($efile->epub_directopen)){
			$output_mime = 'application/epub+zip';
			$output_name=$efile->epub_name;
			$output_name.=".epub";
			header('Content-Type: application/x-download');
			header('Content-Length: '. strlen($output_file));
			header('Content-Disposition: attachment; filename="' . $output_name . '"');
			header('Content-Transfer-Encoding: binary');
			echo $output_file;
		}elseif(!$this->saveFile(ABSPATH.$this->export_file,$output_file)){
			$this->export_error(__('Could not save '.$this->export_file));
			return;
		}else{
			$this->export_complete=true;
			return $this->export_file; 
		}
	}

	function make_htm_word($efile){
		$msg="";

		//Prepare zip archive
		require_once("zipcreate/zipcreate.class.php");
		$tstamp = time();		// timestamp for zip entries
		$epub= new ZipCreate();
				
		$msg.='<html xmlns:v="urn:schemas-microsoft-com:vml" xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:w="urn:schemas-microsoft-com:office:word" xmlns:m="http://schemas.microsoft.com/office/2004/12/omml" xmlns="http://www.w3.org/TR/REC-html40">';
		$msg.="\n\n<head>\n";
	    $msg.='<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />';
		$msg.="\n";
	    $msg.='<title>'.stripslashes($efile->epub_title)."</title>\n";
	    $msg.="<style>\n<!--\n";
	    $msg.=str_replace(";width:100%}","}",$this->make_style($efile));
	    $msg.="\n-->\n</style>";
		$msg.="\n";
	    $msg.="</head>\n";
	    $msg.="<body>\n";
		
		foreach($this->contener as $key => $ops){

			//Pictures integration
			//echo htmlentities($ops);
			preg_match_all('!<img(.*?)src="../images/(.*?)" />!i',$ops,$matches);
			if(!empty($matches[2][0])){
				foreach($matches[2] as $picture){
					//echo $picture;
					$i=$this->findfiletype($picture);
					$img=@file_get_contents($this->localise_file($this->imgtab[$i->name]));
					if(!empty($img)){
						$epub->add_file($img,$efile->epub_name.'/'.$picture,$tstamp);					
					}
				}
			}
			$msg.=str_replace("../images/",$efile->epub_name.'/',$ops);			
		}

		$msg.=$main;
		$msg.="\n</body>\n</html>";
		
		//Formatage word htm
		$msg=mb_eregi_replace("&nbsp;"," ",$msg);
		$msg=mb_eregi_replace("&copy;","©",$msg);
		$msg=str_replace('<div class="pi">','<p class=MsoNormal>',$msg);
		$msg=str_replace('</div>','</p>',$msg);
		$msg=preg_replace('/<div class="(.*)">/i',"<p>",$msg);
		
		//zip
		$output_name=$efile->epub_name.".zip";
		$epub->add_file($msg,$efile->epub_name.".htm",$tstamp);
		$output_file = $epub->build_zip();
		$this->export_file=WP_EPUB_DIR."/".$output_name;
		if(!$this->saveFile(ABSPATH.$this->export_file,$output_file)){
			$this->export_error(__('Could not save '.$this->export_file));
			return false;
		}else{
			$this->export_complete=true;
			$this->okfile[]=$this->export_file;
			return true;
		}
	}
	
	function make_container(){
		$msg='<?xml version="1.0"?>
<container version="1.0" xmlns="urn:oasis:names:tc:opendocument:xmlns:container">
  <rootfiles>
    <rootfile full-path="OEBPS/content.opf" media-type="application/oebps-package+xml" />
  </rootfiles>
</container>';
		return $msg;	
	}

	///Meta and all files listing
	function opf_maker($efile,$imgcover){
		$opf='<?xml version="1.0"?>';
		$opf.="\n";
		$opf.='<package xmlns="http://www.idpf.org/2007/opf" unique-identifier="BookID" version="2.0">';
		$opf.="\n";
	
		$opf.='<metadata xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:opf="http://www.idpf.org/2007/opf">';
		$opf.="\n";
		$opf.="<dc:title>".stripslashes($epub->epub_title)."</dc:title>\n";
		if($efile->epub_french==1){
	    	$opf.="<dc:language>fr</dc:language>\n";
		}else{
			$opf.="<dc:language>en</dc:language>\n";
		}
	    $opf.='<dc:identifier id="BookID" opf:scheme="ISBN">'.$this->epub_isbn."</dc:identifier>\n";
	    $opf.='<dc:creator opf:role="aut">'.stripslashes($this->epub_author)."</dc:creator>\n";
	    $opf.='<dc:publisher>'.stripslashes($this->epub_author)."</dc:publisher>\n";
	    //$opf.='<dc:genre>'.stripslashes("blog")."</dc:genre>\n";
	    if(!empty($imgcover->tmp)){
	    	$opf.='<meta name="cover" content="cover-image"/>';    	
			$opf.="\n";
		}
		$opf.="</metadata>\n";
	 
		$opf.="<manifest>\n";
	    $opf.='<item id="ncx" href="toc.ncx" media-type="application/x-dtbncx+xml"/>';
		$opf.="\n";
	    $opf.='<item id="stylesheet" href="styles/main.css" media-type="text/css"/>';
		$opf.="\n";
		
		//Images
		if(!empty($imgcover->tmp)){
			//print_r($imgcover);
			//echo $imgcover->type;
			$texten=$this->findfiletype($imgcover->name);
	    	$opf.='<item id="cover-image" href="images/imgcover.'.$imgcover->type.'" media-type="'.$texten->type.'"/>';
			$opf.="\n";
		}
	    foreach($this->imgtab as $key => $value){
			$texten=$this->findfiletype($value);
	    	$opf.='<item id="image.'.$key.'" href="images/'.$key.'.'.$this->imgxtension($value).'" media-type="'.$texten->type.'"/>';
			$opf.="\n";
		}

		//Text
		$opf.='<item id="cover" href="text/cover.xhtml" media-type="application/xhtml+xml"/>';
	    $opf.="\n";
	    $opf.='<item id="copyright" href="text/copyright.xhtml" media-type="application/xhtml+xml"/>';
	    $opf.="\n";
		foreach($this->contener as $key => $ops){
			$opf.='<item id="book'.str_pad($key,4,"0",STR_PAD_LEFT).'" href="text/book'.str_pad($key,4,"0",STR_PAD_LEFT).'.xhtml" media-type="application/xhtml+xml"/>'."\n";
		}
	    $opf.='<item id="colophon" href="text/colophon.xhtml" media-type="application/xhtml+xml"/>';
	    $opf.="\n";
	    $opf.="</manifest>\n";
	 
		$opf.="<spine toc=\"ncx\">\n";
	    $opf.="<itemref idref=\"cover\"/>\n";
	    $opf.="<itemref idref=\"copyright\"/>\n";
	    foreach($this->contener as $key => $ops){
			$opf.='<itemref idref="book'.str_pad($key,4,"0",STR_PAD_LEFT).'"/>'."\n";
		}
	    $opf.="<itemref idref=\"colophon\"/>\n";
		$opf.="</spine>\n";
		
		$opf.="<guide>\n";
		$opf.="<reference  href=\"text/cover.xhtml\" type=\"cover\" title=\"Cover\"/>\n";
		$opf.="<reference  href=\"text/copyright.xhtml\" type=\"copyright\" title=\"Copyright\"/>\n";
		$opf.="<reference  href=\"text/book0001.xhtml\" type=\"text\" title=\"Text\"/>\n";
		$opf.="<reference  href=\"text/colophon.xhtml\" type=\"colophon\" title=\"Colophon\"/>\n";
		$opf.="</guide>";
	 
		$opf.='</package>';
		return $opf;
	}

	//Table of contents
	function ncx_maker($efile){
		//print_r($efile);
		$msg='<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE ncx PUBLIC "-//NISO//DTD ncx 2005-1//EN" "http://www.daisy.org/z3986/2005/ncx-2005-1.dtd">
<ncx version="2005-1" xml:lang="en" xmlns="http://www.daisy.org/z3986/2005/ncx/">
<head>
    <meta name="dtb:uid" content="'.$efile->epub_isbn.'"/>';
    if($efile->epub_content==0){
    	$msg.="\n".'<meta name="dtb:depth" content="1"/>'."\n";
    }else{
    	$msg.="\n".'<meta name="dtb:depth" content="2"/>'."\n";
    }	
    $msg.='<meta name="dtb:totalPageCount" content="0"/>
    <meta name="dtb:maxPageNumber" content="0"/>
</head>
 
<docTitle>
    <text>'.stripslashes($efile->epub_title).'</text>
</docTitle>
 
<docAuthor>
    <text>'.stripslashes($efile->epub_author).'</text>
</docAuthor>
 
<navMap>';


		$msg.='<navPoint class="chapter" id="cover" playOrder="1">'."\n";
		$msg.='<navLabel><text>Cover</text></navLabel>'."\n";
		$msg.='<content src="text/cover.xhtml"/>'."\n";
		$msg.="</navPoint>\n"; 

		$msg.='<navPoint class="chapter" id="copyright" playOrder="2">'."\n";
		$msg.='<navLabel><text>Copyright</text></navLabel>'."\n";
		$msg.='<content src="text/copyright.xhtml"/>'."\n";
		$msg.="</navPoint>\n"; 
		
		$max=count($this->contener);
		$ordi=3;
		$year="";
		$month="";
		foreach($this->contener as $key => $ops){
			
			//if($ordi>10) continue;

			$h3=$this->title[$key];
			//$h3=mb_convert_case($this->title[$key], MB_CASE_TITLE, "UTF-8");
			if(empty($h3)) continue;

			$id='book'.str_pad($key,4,"0",STR_PAD_LEFT);

			if($efile->epub_content==1&&isset($this->year[$key])&&$year!=$this->year[$key]){
				if(!empty($year)) $msg.="</navPoint>\n";
				$year=$this->year[$key];
				$msg.='<navPoint class="h1" id="'.$id.'_y" playOrder="'.$ordi.'">'."\n";
				$msg.='<navLabel><text>'.$year.'</text></navLabel>'."\n";
				$msg.='<content src="text/'.$id.'.xhtml"/>'."\n";
				$ordi++;
			}

			if($efile->epub_content==1&&isset($this->month[$key])&&$month!=$this->month[$key]){
				if(!empty($month)) $msg.="   </navPoint>\n";
				$month=$this->month[$key];
				$msg.='   <navPoint class="h2" id="'.$id.'_m" playOrder="'.$ordi.'">'."\n";
				$msg.='   <navLabel><text>'.$month.'</text></navLabel>'."\n";
				$msg.='   <content src="text/'.$id.'.xhtml"/>'."\n";
				$ordi++;
			}
			
			$msg.='      <navPoint class="chapter" id="'.$id.'" playOrder="'.$ordi.'">'."\n";
			$msg.='      <navLabel><text>'.str_replace("&nbsp;"," ",$h3).'</text></navLabel>'."\n";
			$msg.='      <content src="text/'.$id.'.xhtml"/>'."\n";
			$msg.="      </navPoint>\n"; 
			$ordi++;

		}
		if(!empty($month)) $msg.="   </navPoint>\n";
		if(!empty($year)) $msg.="</navPoint>\n";
	
		$msg.='<navPoint class="chapter" id="colophon" playOrder="'.$ordi.'">'."\n";
		$msg.='<navLabel><text>Colophon</text></navLabel>'."\n";
		$msg.='<content src="text/colophon.xhtml"/>'."\n";
		$msg.="</navPoint>\n";

		$msg.='</navMap></ncx>';
		return $msg;
	}

	function ops_maker($main,$efile){
		$msg='<?xml version="1.0" encoding="UTF-8" ?>';
		$msg.="\n";
		$msg.='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'; 
		$msg.="\n";
		$msg.='<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">';	
		$msg.="\n";
		$msg.="<head>\n";
	    $msg.='<meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" />';
		$msg.="\n";
	    $msg.='<title>'.stripslashes($efile->epub_title)."</title>\n";
	    $msg.='<link rel="stylesheet" href="../styles/main.css" type="text/css" />';
		$msg.="\n";
	    $msg.="</head>\n";
	    $msg.="<body>\n";
	    $msg.=$main;
		$msg.="\n</body>\n</html>";
		//exit($msg);
		return $msg;	
	}

	function cover_make($imgcover){
		$msg='<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en-US"><head>
    <title>Cover</title>
    <link rel="stylesheet" type="text/css" href="../styles/main.css" />
    <meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8"/>
</head>
<body>
  	<div></div>
	<p><img id="cover-image" src="../images/imgcover.'.$imgcover->type.'" alt="bookcover" /></p>
</body>
</html>';
		return $msg;
	}
	
	function new_page(){
		$this->contener[$this->cindex]=trim($this->contener[$this->cindex]);
		$this->contener[$this->cindex]=trim($this->contener[$this->cindex],"\n");
		if(empty($this->contener[$this->cindex])) return;
		$this->cindex++;
	}

	function format_text($msg){

		//Delete PHP code
		//echo($msg);
		$msg=preg_replace("/<\?php(.*)\?>/i","",$msg);

		$msg=str_replace("<!--more-->","",$msg);
		$msg=preg_replace("/<a href=\"(.*?)\"><img(.*?)\/>(.*?)<\/a>/i","<img$2/>", $msg);
		//echo($msg);
		$msg=preg_replace("/<object (.*?)>(.*?)<\/object>/i", "", $msg);
		
		//Mark lines
		$msg=mb_eregi_replace(0x0D,"</p><p>",$msg);
		$msg=mb_eregi_replace(0x0A,"",$msg);
		$msg=str_replace("--","—",$msg);
		$msg=str_replace("	","",$msg);
		$msg="<p>".$msg."</p>";
		$msg=str_replace("<p><p>","<p>",$msg);
		$msg=str_replace("</p></p>","</p>",$msg);
		$msg=str_replace("<p></p>","",$msg);
		$msg=str_replace("</p><p></em></p>","</em></p>",$msg);

		$msg=str_replace("<p><h3>","<h3>",$msg);
		$msg=str_replace("</h3></p>","</h3>\n",$msg);
			
		$msg=str_replace("<p><ol></p>","<ol>\n",$msg);
		$msg=str_replace("<p></ol></p>","</ol>\n",$msg);
		$msg=str_replace("<p><ul></p>","<ul>\n",$msg);
		$msg=str_replace("<p></ul></p>","</ul>\n",$msg);
		$msg=str_replace("</p><p><li>","</li>\n<li>",$msg);
		$msg=str_replace("</li></li>","</li>",$msg);
		
		$msg=str_replace("<p><blockquote>","<blockquote>",$msg);
		$msg=str_replace("</blockquote></p>","</blockquote>",$msg);
		$msg=str_replace("<blockquote></em>","<blockquote>",$msg);
		
		if(false&&class_exists(tidy)){
			echo("tidy");
			$tidy = new tidy();
			$msg= @$tidy->repairString($msg,false,"utf8");
		}else{
			$msg="<body>".$msg."</body>";
		}
		
		//echo($msg);
		
		//return $msg;
		if($this->debug&&true) echo(htmlentities($msg));
		$this->fout="";
		$this->pile=array();
		$parser=new simple_html_dom();
		$parser->load($msg);
		foreach($parser->find('body') as $body) {break;}
		//print_r($body);exit;
		$this->html_tree($body);
		$this->fout=str_replace("</p>","",$this->fout);
		//return $msg;
		//if($this->debug&&true) echo(htmlentities($this->fout));
		
		//Final HTML cleaning
		$this->fout=str_replace('<div class="pi"><li>',"<li>",$this->fout);
		$this->fout=str_replace('</li></div>',"</li>",$this->fout);
		$this->fout=preg_replace('/<div class="pi"><div><img (.*?)><\/div><\/div>/is',"<div><img $1></div>",$this->fout);
		$this->fout=str_replace('epub:','http:',$this->fout);
		$this->fout=str_replace('<hr></hr>','<hr/>',$this->fout);
		$this->fout=str_replace('<div class="pi"></div>','',$this->fout);
		$this->fout=str_replace('<br/>/p>','',$this->fout);
		$this->fout=str_replace('</p>','',$this->fout);
		$this->fout=str_replace('<p>','',$this->fout);
		$this->fout=str_replace('/p>','',$this->fout);
		$this->fout=str_replace('[/caption]','',$this->fout);
		$this->fout=str_replace("./li>",".</li>",$this->fout);
		$this->fout=str_replace(">/li>","></li>",$this->fout);
		$this->fout=mb_eregi_replace('</li>\n<div class="pi">',"</li>\n<li>",$this->fout);
		$this->fout=mb_eregi_replace('</li>\n/ol>',"</li>\n</ol>",$this->fout);		
		return $this->fout;
	}
	
	function clean_texte($msg){
		$msg=str_replace(array("=","&","#","<"),array("%3D","%26","%23",""),$msg);
		$msg=str_replace("%26nbsp;","&nbsp;",$msg);
		$msg=str_replace("%26%23233;","é?",$msg);
		$msg=str_replace("%26%23224;","à",$msg);
		$msg=str_replace("%26%23201;","É",$msg);
		$msg=str_replace("%26%23192;","À",$msg);		
		//$msg=str_replace("%26 ","&nbsp; ",$msg);
		$msg=str_replace("<","&lt;",$msg);
		return $msg;
	}
	
	function clean_title($msg){
		$msg=$this->clean_texte($msg);
		$msg=str_replace("%26","et",$msg);
		return $msg; 
	}

	function html_tree($node){
		$indebug=$this->debug;
		
		$child=true;
		$closediv=false;
		$closed=true;
		
		if($indebug) echo("$node->tag<br>");
		
		$tag=strtolower(trim($node->tag));
		if($tag=="text"||empty($tag)){
			$this->fout.=$this->clean_texte($node->innertext);
			if($indebug) echo($node->innertext."<br />");
			$child=false;
		}elseif($tag=="body"||$tag=="div"||$tag=="object"||$tag=="unknown"||$tag=="embed"||$tag=="iframe"){
			$closed=false;
		}elseif($tag=="span"){
		}elseif($tag=="a"){
			$this->fout.="<".$tag;
			foreach($node->attr as $key=>$value){
				if($key=="name") $this->fout.=" id=\"$value\"";
				if($key=="href") $this->fout.=" href=\"".trim(str_replace(array("=","&","#"),array("%3D","%26","%23"),$value))."\"";	//Problem here	
			}
			$this->fout.=">";
		}elseif($tag=="br"){
			$this->fout.='<br/>';
		}elseif($tag=="p"){
			$this->fout.='<div class="pi">';
			//array_push($this->pile,"</div>");
			$closediv=true;
		}elseif($tag=="blockquote"){
			$this->fout.='<div class="blockquote">';
			$closediv=true;
		}elseif($tag=="h1"){
			$this->fout.='<h1 class="main">';
		}elseif($tag=="h2"){
			$this->fout.='<h2 class="main">';
		}elseif($tag=="h3"){
			$this->fout.='<h3 class="main">';
		}elseif($tag=="h4"){
			$this->fout.='<h4 class="main">';
		}elseif($tag=="img"){
			$closed=false;
			foreach($node->attr as $key=>$value){
				if($key=="src") $url=$value;
			}
			if(!empty($url)){
				$this->imgtab[$this->imgindex]=$url;
				$this->fout.='<div><img class="main" alt="image" src="../images/'.$this->imgindex.'.'.$this->imgxtension($url).'" /></div>';
				$this->imgindex++;
			}
		}else{
			$this->fout.="<".$tag.">";
		}
			
		//Explore the children
		if(count($node->nodes)>0 && $child){
			foreach($node->nodes as $child){
				$this->html_tree($child);
			}
		}
		    
		if(!$closed){
		}elseif($closediv){
			$this->fout.="</div>\n";
		}elseif($span){
			$this->fout.="</span>";
		}elseif($tag=="p"){			
		}elseif($tag!="text"&&!empty($tag)&&$tag!="span"&&$tag!="body"&&$tag!="br"&&$tag!="div"&&!eregi(":",$tag)){
			$this->fout.="</".$tag.">";
		}
	}

	function imgxtension($url){
		$info=parse_url($url);
		$info=pathinfo($info['path']);
		return $info['extension'];
	}

	function traducDate($content,$french=0){
		if($french==0) return $content;
		$dateUS=array('January','February','March','April','May','June','July','August','September','October','November','December','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday');
		$dateFR=array('janvier','février','mars','avril','mai','juin','juillet','août','septembre','octobre','novembre','décembre','lundi','mardi','mercredi','jeudi','vendredi','samedi','dimanche');
		return str_replace($dateUS,$dateFR,$content);
	}
	
	function saveFile($name,$msg){
		$this->delfile($name);
		$fp=@fopen($name,'w');
		if(!empty($fp)) {
			@fputs($fp,$msg);
			@fclose($fp);
			return true;
		}else
			return false;
	}
	
	function delfile($img) {
		if(@file_exists($img)){
			if(@unlink($img)) return true;
			$this->error="Impossible to unlink $img (1)";
			if(!@chmod($img,0777)){
				$this->error="Impossible to cmod $img";
				return false;
			}
			if(@unlink($img)) return true;
			$this->error="Impossible to unlink $img (2)";
			return false;
		}else{
			$this->error="File $img do not exist";
			return false;
		}
	}

	//Supprime http:// d'un url
	function outHTTP($ad) {
		return ereg_replace('http://','',$ad);
	}

	function findfiletype($img){
		$filename=basename($img);
	   	$i->ext=strtolower(substr(strrchr($filename,"."),1));
	   	$i->name=str_replace(".".$i->ext,"",$filename);
		switch($i->ext){
			case "gif": $i->type="image/gif"; break;
	     	case "png": $i->type="image/png"; break;
	     	case "jpeg":
	     	case "jpg": $i->type="image/jpeg"; break;
		}
		
		return $i;
	}

	function abspath($url){
		if(!eregi("http://",$url))
			return get_settings('siteurl').$url;
		else
			return $url;		
	}

	function localise_file($url){
		if(!eregi("http://",$url)) return ABSPATH.$url;
		$url=$this->abspath($url);
		$url=str_replace(get_settings('siteurl'),ABSPATH,$url);
		return $url;
	}
	
	function preloadImage($imgfile){
		if(!isset($imgfile['size'])){
			$this->error="Image vide";
			return false;
		}
		$this->error=$imgfile['error'];
		if($this->error==2){
			$this->export_error="HTML max size overflow!";
			return false;
		}
		if($this->error>0) return false;

		$img->name=$imgfile['name'];
		$img->tmp=$imgfile['tmp_name'];
		$it=explode('/',$imgfile['type']);
		$img->type=str_replace(array("pjpeg","jpeg"),"jpg",$it[1]);
		$img->size=$imgfile['size'];

		return $img;
	}

	function display_filesize($filesize){
		if(is_numeric($filesize)){
			$decr = 1024; $step = 0;
			$prefix = array('Byte','KB','MB','GB','TB','PB');
	       
			while(($filesize / $decr) > 0.9){
	        	$filesize = $filesize / $decr;
	        	$step++;
	    	}
	    	return round($filesize,2).' '.$prefix[$step];
	    }else{
	    	return 'NaN';
	    }
	}

}

add_action('admin_menu','wp2epub_admin_menu');
function wp2epub_admin_menu() {
	// Add a new submenu under tools
	add_management_page('wp2epub','wp2epub','edit_themes', basename(__FILE__), 'wp2epub_menu');
}

add_filter('plugin_action_links_'.plugin_basename(__FILE__),"wp2epub_addConfigureLink", 10, 2);
function wp2epub_addConfigureLink($links) { 
	$link = '<a href="tools.php?page=wp2epub.php">' . __('Settings') . '</a>';
	array_unshift( $links, $link ); 
	return $links;
}

function wp2epub_menu(){
	$epub=new wp2epub();
	$epub->maker();
	$epub->menu();
}

function wp2epub_external($efile){
	$epub=new wp2epub();
	$epub->perform_externalexport($efile);
}

?>